__author__     = "Aaron Straup Cope"
__url__        = "http://aaronland.info/python/w5"
__version__    = "1.0a3"
__cvsversion__ = "$Revision: 1.11 $"
__date__       = "$Date: 2004/05/19 12:38:14 $"
__copyright__  = "%s\n%s\n%s" % \
                 ("This application is licensed under the",
                  "Creative Commons Attribution-NonCommercial License",
                  "http://creativecommons.org/licenses/by-nc/1.0/")

__license__    = "This application is licensed under the Creative \
Commons Attribution-NonCommercial License. To view a copy of this \
license, visit http://creativecommons.org/licenses/by-nc/1.0/ or send \
a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, \
California 94305, USA."

# $Id: rDisplay.py,v 1.11 2004/05/19 12:38:14 asc Exp $

from rConstants  import *
from rPanel      import rPanel
from rConfig     import rConfig
from rPrefs      import rPrefs

from wxPython.wx import *
from cStringIO   import StringIO

from xmlrpclib import Server
from os        import geteuid,name
from os.path   import isdir,isfile,join
from random    import choice
from thread    import start_new_thread
from pwd       import getpwuid

class rDisplay(wxFrame):

    def __init__(self, parent, ID, title):

        #
        
        uid          = geteuid()
        homedir      = getpwuid(uid)[5]
        cfg          = join(homedir,".rImage.xml")

        self.Config  = rConfig(cfg)
	self.LoadConfig()

        #
        
        app = self.Config.App()

        # this is kind of ugly...
        # to reconsider...
        
        max_x = NS_W5 + W5_APP_MAXWIDTH
        max_y = NS_W5 + W5_APP_MAXHEIGHT

        pos_x = NS_W5 + W5_APP_POSX
        pos_y = NS_W5 + W5_APP_POSY
        
        # set initial height for window
        
        if app.has_key(max_y) and int(app[max_y]) > 0:
            self.MaxHeight = int(app[max_y])
        else:
            max_y = wxSystemSettings_GetMetric(wxSYS_SCREEN_Y)
            self.MaxHeight = int(int(max_y * .75) / 2)
        
        if app.has_key(max_x) and int(app[max_x]) > 0:
            self.MaxWidth  = int(app[max_x])
        else:
            max_x = wxSystemSettings_GetMetric(wxSYS_SCREEN_X)
            self.MaxWidth = int(int(max_x * .75) / 2)

        # set initial position for window
        
        if app.has_key(pos_x) and app.has_key(pos_y) \
           and int(app[pos_x]) > 0 and int(app[pos_y]) :

            pos = wxPoint(int(app[pos_x]),
                          int(app[pos_y]))
            
        else:
            pos = wxDefaultPosition

        # Check to see if w/y is greater than
        # screen or just assume the user knows
        # what they're doing...

        wxFrame.__init__(self, parent, ID, title,
                         pos,
			 wxSize(self.MaxWidth,
			        self.MaxHeight))

        self.Panel   = rPanel(self, -1)
        
	#

        self.Data    = {}
        self.Image   = None
	self.Caption = None
	self.Paused  = false

        FileMenu = wxMenu()

        FileMenu.Append(ID_PAUSE,
			MENU_PAUSE,
			DESCRIBE_PAUSE)

        FileMenu.Append(ID_RESUME,
			MENU_RESUME,
			DESCRIBE_RESUME)

        FileMenu.AppendSeparator()
                        
        FileMenu.Append(ID_EXIT,
			MENU_QUIT,
			DESCRIBE_QUIT)

        FileMenu.Enable(ID_RESUME,false)

        EditMenu = wxMenu()

	EditMenu.Append(ID_MAXWIDTH,
			"&Width",
			"Set maximum width for an image.")

	EditMenu.Append(ID_MAXHEIGHT,
			"&Height",
			"Set maximum height for an image.")

        EditMenu.AppendSeparator()

        EditMenu.Append(ID_PREFS,
			"&Services",
			"Services")

        ToolsMenu = wxMenu()
        ToolsMenu.Append(ID_INFO,
			 MENU_INFO,
	                 DESCRIBE_INFO)	

        HelpMenu = wxMenu()
        HelpMenu.Append(ID_ABOUT,
			MENU_ABOUT,
	                DESCRIBE_ABOUT)
		    
        menuBar = wxMenuBar()
        menuBar.Append(FileMenu,  MENUBAR_FILE);
        menuBar.Append(EditMenu,  "&Edit");
        menuBar.Append(ToolsMenu, MENUBAR_TOOLS);
        menuBar.Append(HelpMenu,  MENUBAR_HELP);

        self.SetMenuBar(menuBar)
        
        EVT_MENU(self, ID_PAUSE,     self.Pause)
        EVT_MENU(self, ID_RESUME,    self.Resume)
        EVT_MENU(self, ID_MAXWIDTH,  self.SetMaxWidth)
        EVT_MENU(self, ID_MAXHEIGHT, self.SetMaxHeight)
        EVT_MENU(self, ID_INFO,      self.Info)
        EVT_MENU(self, ID_PREFS,     self.Services)
        EVT_MENU(self, ID_ABOUT,     self.About)
        EVT_MENU(self, ID_EXIT,      self.Quit)

        EVT_CLOSE(self,self.Quit)
        
	# Doesn't appear to work under
	# py-wxPython (FreeBSD)
        EVT_MENU_CLOSE(self,self.SetCaption)

	EVT_KEY_DOWN(self.Panel,  self.KeyDown)

        #

        self.CreateStatusBar()

    def LoadConfig(self):
        
        if self.Config.Load():
            return self.Config

        #
        
        errmsg = "failed to load config file : '%s'" % cfg
        
        self.ReportError(errmsg)
        return false
    
    def RandomService (self):
	url = choice(self.Config.ListServices([PROTOCOL_XMLRPC]))
	return self.Config.DescribeService(url)
    
    def Yield(self):
        
        # This causes Windows to hang
        # FreeBSD hangs without it...

        if name == "nt":
            pass
        else:
            wxSafeYield(self,true)

    def ReportError(self,msg):
	if msg:
	   self.SetStatusText("[%s]" % self.PrepareStatusText(msg))
	else: 
	   self.SetStatusText("")

        self.Yield()

    def ReportActivity(self,msg):
	if msg:
	   self.SetStatusText("[%s]" % self.PrepareStatusText(msg))
	else: 
	   self.SetStatusText("")

        self.Yield()

    def Services (self,event):

        prefs = rPrefs(self.Panel,-1,self.LoadConfig())

	(x,y) = self.GetPosition()
	prefs.SetPosition((x + 50,y + 50))

	prefs.Show()

    def Pause(self,event):

        if self.Paused == true:
            return true
        
        self.Paused = true
        self.ReportActivity(MSG_PAUSED)

        # http://wiki.wxpython.org/index.cgi/ \
        # wxPython_20Platform_20Inconsistencies

        menu = self.GetMenuBar().FindItemById(-1).GetMenu() 
        menu.Enable(ID_PAUSE,false)
        menu.Enable(ID_RESUME,true)
        
    def Resume(self,event):

        if self.Paused == false:
            return true
        
        self.Paused = false

        # http://wiki.wxpython.org/index.cgi/ \
        # wxPython_20Platform_20Inconsistencies
        
        menu = self.GetMenuBar().FindItemById(-1).GetMenu() 
        menu.Enable(ID_PAUSE,true)
        menu.Enable(ID_RESUME,false)

    def KeyDown(self,event):
        
	if event.ControlDown():
            keycode = event.GetKeyCode()
        else:
            event.Skip()
            return true
        
        if keycode <= 256:
            keyname = chr(keycode)
        else:
            event.Skip()
            return true
        
	if keyname == "A":
            self.About(event)
        elif keyname == "H":
            self.SetMaxHeight(event)
        elif keyname == "I":
            self.Info(event)
        elif keyname == "P":
            self.Pause(event)
        elif keyname == "Q":
            self.Quit(event)
        elif keyname == "R":
            self.Resume(event)
        elif keyname == "S":
            self.Services(event)            
        elif keyname == "W":
            self.SetMaxWidth(event)
        else:
            event.Skip()
	
	return true

    
    def About(self, event):
        dlg = wxMessageDialog(self,
                              DIALOG_ABOUT,
                              TITLE_ABOUT,
			      wxOK | wxICON_INFORMATION)
        dlg.ShowModal()
        dlg.Destroy()

    def Info(self,event):

	if len(self.Data) == 0:
	   msg = ERR_IMAGEINFO
	else:
           msg = "%s\n" % (self.Data["who"])
           
           if self.Data["what"]:
               msg = "%s \"%s\"\n" % (msg,self.Data["what"])
              
           msg = "%s\n" % (msg)

           # god help me, there
           # *must* be a better
           # way...
           
           if self.Data["where"]:
               msg = "%s%s" % (msg,self.Data["where"])
              
           if self.Data["when"]:
               if self.Data["where"]:
                   msg = "%s, %s" % (msg,self.Data["when"])
               else:
                   msg = "%s%s" % (msg,self.Data["when"])
                   
        dlg = wxMessageDialog(self,
                              msg,
                              TITLE_INFO,
			      wxOK | wxICON_INFORMATION)
        dlg.ShowModal()
        dlg.Destroy()

    def SetMaxWidth(self,event):
        max = wxGetTextFromUser("Please enter a number.\n"
				"Current max width is " + str(self.MaxWidth),
	    	                "Set max width")

        if max == "":
            return
        
        try:
            self.MaxWidth = int(max)
        except:
            errmsg = "failed to assign %s as maximum width" % str(max)
            self.ReportError(errmsg)
            return false
        
        self.Config.SetMaxWidth(self.MaxWidth)
    #

    def SetMaxHeight(self,event):
        max = wxGetTextFromUser("Please enter a number.\n"
				"Current max height is " + str(self.MaxHeight),
	    	                "Set max height")

        if max == "":
            return

        try:
            self.MaxHeight = int(max)
        except:
            errmsg = "failed to assign %s as maximum height" % str(max)
            self.ReportError(errmsg)
            return false

        self.Config.SetMaxHeight(self.MaxHeight)

    def Quit(self, event):

        # move all of this 
        # into self.__del__ ?
        
        (x,y) = self.GetPosition()

        self.Config.SetPositionX(x)
        self.Config.SetPositionY(y)
        
	# this is required by "nt"
	# and, I think, "os x"
	self.Panel.Destroy()

        self.Destroy()
        
    def DisplayRandom(self):

        self.ReportActivity(MSG_POLLING)

        try:
            service = self.RandomService()
        except:
            self.ReportError(ERR_RANDOMSERVER)
            return false

	server = Server(service.Endpoint())

        args   = {"login"  : str(service.Login()),
                  "filter" : str(service.Filter())}

        # wrap this in a thread so that the rest of
        # application (preferences, etc.) doesn't have
        # to wait for the xmlrpclib stuff to stop
        # blocking - I'm not sure what other issues
        # this will raise and hope to suss this during
        # the beta period.
        
        start_new_thread(self.SetImage,(server,args))

    def SetImage(self,server,args):
        
        try:
            resp = server.w5.RandomImage(args)
        except:
            self.ReportError(ERR_POLLING)
            return false

        self.ReportActivity(MSG_PROCESSING)

        try:
            data = StringIO(resp["image"].data)         
        except:
            self.ReportError(ERR_STRINGIFY)
            return false

        try:
            image = wxImageFromStream(data)
        except:
            self.ReportError(ERR_STREAMIFY)
            return false

	try:
	    scaled = self.ScaleImage(image)
	except:
            self.ReportError(ERR_SCALED)
            return false

        try:
            self.Panel.Display(scaled)
        except:
            self.ReportError(ERR_DISPLAY)
            return false

	self.SetWindow(scaled)

        # the unquote_plus stuff is a hack;
        # see notes in import block above

	self.Data["who"]   = resp["who"]
	self.Data["what"]  = resp["what"]
	self.Data["where"] = resp["where"]
	self.Data["when"]  = resp["when"]
        
	if self.Data["what"]:
	   caption = "%s, %s" % (self.Data["who"],self.Data["what"])
	else:
	   caption = self.Data["who"]

	#

	caption = self.PrepareStatusText(caption,
					 int(image.GetWidth() * STATUSTEXT))

	self.Caption = caption
	self.SetCaption()

	# check for UID here and add to a bloom filter
    
    def SetCaption(self,event=None):
	if self.Caption:
	   self.SetStatusText(self.Caption)
	else:
	   self.SetStatusText("")

    def PrepareStatusText(self,txt,max=0):

	# Okay, now we have to make sure that the
	# text will fit in the status bar

        (txt_x,txt_y) = self.GetTextExtent(txt)

	if max == 0:
	   max = int(self.GetSize()[0] * STATUSTEXT)

	if txt_x > max:

	   while txt_x > max:

		# please make the python keeners
		# shut the fuck up about how great
		# their language is. my kingdom for
		# a substring function...

		txt = txt[0:len(txt) - 1]

		# just in case

		if len(txt) == 1:
		   txt = ""
		   break

	        (txt_x,txt_y) = self.GetTextExtent(txt)

	   txt = "%s..." % txt
	
	#

	return txt

    def ScaleImage(self,img):

        W = img.GetWidth()
        H = img.GetHeight()

	if W < self.MaxWidth and H < self.MaxHeight:
	   return img

        if W > H:
            NewW = self.MaxWidth
            NewH = self.MaxWidth * H / W
        else:
            NewH = self.MaxHeight
            NewW = self.MaxHeight * W / H

        return img.Scale(NewW,NewH)

    def SetWindow(self,image):

	scr_x = wxSystemSettings_GetMetric(wxSYS_SCREEN_X)
	scr_y = wxSystemSettings_GetMetric(wxSYS_SCREEN_Y)

	(sb_x,sb_y)   = self.GetStatusBar().GetSize()
	(mb_x,mb_y)   = self.GetMenuBar().GetSize()
        
	(pos_x,pos_y) = self.GetPosition()

        # must find a way to measure
	# the width of the various
	# windowing border elements
        
        count_border_offset = 2.25
        width_border_side   = 3

        if name == "nt":
            count_border_offset *= 2
            width_border_side   *= 2.75

            # windows returns something
            # cracked like (999334,0)
            # this is a bug...
            
            mb_y = 25

        #
        
	img_x  = image.GetWidth()
        img_x += (BORDER * count_border_offset)

	img_y  = image.GetHeight()
        img_y += (BORDER * width_border_side)

	# no comment

	if name == "nt":
	   img_x -= 1

        #
        
	win_x = int(img_x)
	win_y = int(img_y + sb_y + mb_y)

	new_x = pos_x
	new_y = pos_y

	move  = false

	#

	if (pos_x + win_x) > scr_x:
	   new_x = scr_x - (win_x + (BORDER * count_border_offset))
	   move  = true

	if (pos_y + win_y) > scr_y:
	   new_y = scr_y - (win_y + (BORDER * count_border_offset))
	   move  = true

	if move:
	   self.SetPosition((new_x,new_y))   

	#

	self.SetSize(wxSize(win_x,win_y))
