__author__     = "Aaron Straup Cope"
__url__        = "http://aaronland.info/python/w5"
__version__    = "1.0a3"
__cvsversion__ = "$Revision: 1.18 $"
__date__       = "$Date: 2004/05/19 12:38:14 $"
__copyright__  = "%s\n%s\n%s" % \
                 ("This application is licensed under the",
                  "Creative Commons Attribution-NonCommercial License",
                  "http://creativecommons.org/licenses/by-nc/1.0/")

__license__    = "This application is licensed under the Creative \
Commons Attribution-NonCommercial License. To view a copy of this \
license, visit http://creativecommons.org/licenses/by-nc/1.0/ or send \
a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, \
California 94305, USA."

# $Id: rEdit.py,v 1.18 2004/05/19 12:38:14 asc Exp $

from wxPython.wx import *

ID_ENDPOINT  = wxNewId()
ID_TITLE     = wxNewId()
ID_LOGIN     = wxNewId()
ID_FILTER    = wxNewId()
ID_OK        = wxNewId()
ID_CANCEL    = wxNewId()

class rEdit (wxFrame) :

    def __init__ (self,parent,style,cfg,endpoint=None):

	self.__parent__   = parent

        self.__cfg__      = cfg
        self.__service__  = None
        self.__input__    = {"endpoint":None,"title":None,
                             "login":None,"filter":None}

        self.__controls__ = {}
        self.__ctrlkeys__ = []
        
        #
        
        if endpoint != None:
            self.__service__ = self.__cfg__.DescribeService(endpoint)
            title = "Edit %s " % (self.__service__.Title())            
        else:        
            title = "Add a new service"

        #
        
        wxFrame.__init__(self,parent,style,title)
        (min_x,min_y) = self.GetBestSize()

        #

        # fs = self.GetFont().GetPointSize()
        # bf = wxFont(fs, wxSWISS, wxNORMAL, wxBOLD)

        #

        self.__addcontrol(wxTextCtrl(self,ID_ENDPOINT,
                                     size = (min_x,-1)))
        
        self.__addcontrol(wxTextCtrl(self,ID_TITLE,
                                     size = (min_x,-1)))
        
        self.__addcontrol(wxTextCtrl(self,ID_LOGIN,
                                     size = (min_x,-1)))

        self.__addcontrol(wxCheckBox(self,ID_FILTER,
                                     "enable filter"))
        
        self.__addcontrol(wxButton(self,ID_OK,
                                   "OK"))
        
        self.__addcontrol(wxButton(self,ID_CANCEL,
                                   "Cancel"))
        
        #

        spacer = wxSize(5,5)
        
        sz_required = wxStaticBoxSizer(wxStaticBox(self,-1,"required"),
                                       wxVERTICAL)

        sz_required.Add(spacer)
	sz_required.Add(wxStaticText(self,-1,"endpoint"),
			0,wxALIGN_RIGHT)
        sz_required.Add(self.__controls__[ID_ENDPOINT])
        
        #

        sz_optional = wxStaticBoxSizer(wxStaticBox(self,-1,"optional"),
                                          wxVERTICAL)
        sz_optional.Add(spacer)

	sz_optional.Add(wxStaticText(self,-1,"title"),
                        0,wxALIGN_RIGHT)
        sz_optional.Add(self.__controls__[ ID_TITLE ])
        sz_optional.Add(spacer)

	sz_optional.Add(wxStaticText(self,-1,"login"),
                        0,wxALIGN_RIGHT)        
        sz_optional.Add(self.__controls__[ID_LOGIN])
        sz_optional.Add(spacer)

        sz_optional.Add(self.__controls__[ID_FILTER])
                
        sz_control  = wxBoxSizer(wxHORIZONTAL)

        sz_control.Add(self.__controls__[ID_OK])
        sz_control.Add(spacer)
        sz_control.Add(self.__controls__[ID_CANCEL])
        
        #

        sz_body = wxBoxSizer(wxVERTICAL)         

        sz_body.Add(sz_required)
        sz_body.Add(spacer)        
        sz_body.Add(sz_optional)

        sz_body.Add(spacer)
        sz_body.Add(spacer)
        
        sz_body.Add(sz_control,0,wxALIGN_RIGHT)

        sz_padding = wxBoxSizer(wxHORIZONTAL)
        sz_padding.Add(spacer)
        sz_padding.Add(sz_body)
        sz_padding.Add(spacer)

        sz_main = wxBoxSizer(wxVERTICAL)
        sz_main.Add(spacer)
        sz_main.Add(sz_padding)
        sz_main.Add(spacer)
        
        # someone please explain to me why this is
        # better than : if (my $foo = $self->{foo})
    
        if  self.__service__ != None:

            self.__input__["endpoint"] = self.__service__.Endpoint()
            self.__controls__[ID_ENDPOINT].SetValue(self.__input__["endpoint"])

            if self.__service__.Title() != None and \
               self.__service__.Title() != self.__service__.Endpoint() :

                self.__input__["title"] = self.__service__.Title()
                self.__controls__[ID_TITLE].SetValue(self.__input__["title"])

            if self.__service__.Login() != None:
                self.__input__["login"] = self.__service__.Login()
                self.__controls__[ID_LOGIN].SetValue(self.__input__["login"])
                
            if self.__service__.Filter() != None:

                self.__input__["filter"] = 1
                self.__controls__[ID_FILTER].SetValue(self.__input__["filter"])
        
        #
        
	self.SetSizer(sz_main)
        self.SetAutoLayout(1)        

        self.CreateStatusBar()
        sz_main.Fit(self)

        self.__controls__[ID_ENDPOINT].SetFocus()
        self.__controls__["current"] = 0
        
        #
        
        EVT_BUTTON(self, ID_OK, self.OK)
        EVT_BUTTON(self, ID_CANCEL, self.Cancel)

        EVT_TEXT(self,ID_ENDPOINT, self.__endpoint)
        EVT_TEXT(self,ID_LOGIN, self.__login)
        EVT_TEXT(self,ID_TITLE, self.__title)

        EVT_CHECKBOX(self,ID_FILTER, self.__filter)

	EVT_KEY_DOWN(self,self.KeyDown)    

    #
    
    def __endpoint (self,event):
        self.__input__["endpoint"] = event.GetString()

    #
    
    def __login (self,event):
        self.__input__["login"] = event.GetString()

    #
    
    def __title (self,event):
        self.__input__["title"] = event.GetString()

    #
    
    def __filter (self,event):
        self.__input__["filter"] = event.IsChecked()

    #
    
    def KeyDown(self,event):

        keycode = event.GetKeyCode()

        if keycode == WXK_TAB :

            cur   = self.__controls__["current"]
            count = len(self.__ctrlkeys__) - 1

            #
            
	    if event.ShiftDown() :
                if cur == 0 :
                    cur = count
                else :
                    cur = cur - 1
	    else :
                if cur >= count :
                    cur = 0
                else :
                    cur = cur + 1

            #
            
            id  = self.__ctrlkeys__[ cur ]

            self.__controls__["current"] = cur            
            self.__controls__[ id ].SetFocus()

        elif keycode == WXK_RETURN :

            cur = self.__controls__["current"]
            id  = self.__ctrlkeys__[ cur ]
            
            if id == ID_OK:
                self.OK(event)
            elif id == ID_CANCEL:
                self.Cancel(event)
            else:
                pass

        else :
            pass
        
    #
    
    def OK (self,event):

        if self.__input__["endpoint"] == None:
            self.Error("You must supply an endpoint.")
            return false
        
        #

        if self.__service__ == None :
            self.__cfg__.AddService(self.__input__)
        else :
            self.__cfg__.SetService(self.__input__)

        #
        
	self.__cfg__.Write()

        # YA hack -- I need to figure out how to
        # get this to be called automagically in
        # rPrefs.py when the rEdit frame is destroyed
        
        self.GetParent().LoadServices()
        self.GetParent().Selected(self.__input__["endpoint"])
	self.GetParent().EnableControls()

	self.Destroy()

    #
    
    def Cancel(self,event):
	self.GetParent().EnableControls()
        self.Destroy()

    #
    
    def Error (self,msg) :
        dlg = wxMessageDialog(self,
                              msg,
                              "Error",
			      wxOK | wxICON_INFORMATION)
        dlg.ShowModal()
        dlg.Destroy()

    #
    
    def __addcontrol (self,ctrl) :

        id = ctrl.GetId()
        
        self.__controls__[ id ] = ctrl
        self.__ctrlkeys__.append(id)
